/**
* by H. Timucin OZdemir
*/

//** Necessary JAVA Classes
import java.awt.*;
import java.applet.*;
import java.util.*;
import java.net.*;

//** Apperantly we need External Authoring Interface classes
import vrml.external.Node;
import vrml.external.Browser;
import vrml.external.field.*;
import vrml.external.exception.*;

public class 
Image3D extends Applet 
{  

   boolean                     DEBUG             = true;

   Browser                     browser           = null;
   Node                        rootNode          = null;
   Node                        viewpoint          = null;
   EventInMFNode               addChildren     = null;
   EventInMFNode               removeChildren  = null;
   EventInSFVec3f              set_position = null;
   Node                myNode[]      = null;
   Node                myTransform[] = null;

   ImageArray myImage;  

   UI myUI;                 // User Interface

   String currentFileName = null;
         
   /** 
   * User Interface 
   */
   public void 
   init()
   { 
      myUI = new UI(this);

      add(myUI);
      
      currentFileName = new String("frog.gif");

      LoadImage lim = new LoadImage(this,currentFileName);

      myImage = ImageArray.getImageArray(lim.GetImage(),this);

      if(DEBUG) System.out.println(" End of Init() ");

   }// end of init()

   public void
   start()
   {

      /** Let's first get the handle of VRML 2.0 Browser */
      browser = (Browser) Browser.getBrowser(this);

      if(DEBUG==true) System.out.println("after browser handle ");
         
      try {
            if(DEBUG==true) System.out.println("before rootNode handle ");

            /** Get the Handle Of objects  */
            rootNode = browser.getNode("DATA");
            viewpoint = browser.getNode("View1");

            if(DEBUG==true) System.out.println("after rootNode handle ");
      
      } catch (InvalidNodeException e)
        { System.out.println("Invalid Node Exception"); }
      

      /** Get EventIns of the rootNode */
      addChildren = (EventInMFNode) rootNode.getEventIn("addChildren");
      removeChildren = (EventInMFNode) rootNode.getEventIn("removeChildren");
      
      if(DEBUG == true ) System.out.println(" events are registered !! ");      

      /** Get EventIns of the viewer Node */
      set_position = (EventInSFVec3f) viewpoint.getEventIn("position");


   }// end of start()
    
   /**
   *
   */
   public void 
   updateScreen(String fileName, String filterName)
   {

       int filterType = 0;

       if(DEBUG)
       {  
          System.out.println(" fileName : "+fileName);  
          System.out.println(" filterName : "+filterName);  
       }

       if(fileName!=currentFileName)
       {
          currentFileName = fileName;
          LoadImage lim = new LoadImage(this,currentFileName);

          myImage = ImageArray.getImageArray(lim.GetImage(),this);
       }

       if(filterName!=null)
       {
          if(filterName.equals("Average")) filterType = 1;
          else if(filterName.equals("Median")) filterType = 2;
       }

       FilterManager fm = new FilterManager();

       int imgPxls[] = new int[myImage.getXDim()*myImage.getYDim()];
       int pixs[] = myImage.getPixels();
       for(int i=0;i<myImage.getYDim();i++) 
           for(int j=0;j<myImage.getXDim();j++) 
             imgPxls[i*myImage.getXDim()+j] = pixs[i*myImage.getXDim()+j];



       switch(filterType)
       {
              case 1: // Average filtering
                      imgPxls = fm.applyAverage(imgPxls, myImage.getXDim(), 
                                                         myImage.getYDim());
                      break;

        }

        /** Get rid of the previous node from world **/
        if(myNode!=null) removeChildren.setValue(myNode);

        VrmlProducer prod = new VrmlProducer();
        String vrmlString = prod.produceElevationGrid(myImage.getPixels(),
                                    myImage.getXDim(), myImage.getYDim());

        /** Create a new Node  */
        myNode = browser.createVrmlFromString(vrmlString);

        float npos[] = new float[3];
 
        npos[0] = myImage.getXDim()/2.0f;
        npos[1] = 25.0f;
        npos[2] = 1.5f*myImage.getYDim();

        /** Add this node to the scene */
        addChildren.setValue(myNode);

        /** Set the viewer's position */
        set_position.setValue(npos);
          
   }// end of updateScreen()
    
}// end of class Image3D
